petsc-3.10.5 2019-03-28
Report Typos and Errors

# PCASM

Use the (restricted) additive Schwarz method, each block is (approximately) solved with its own KSP object.

### Options Database Keys

| -pc_asm_blocks <blks> | - Sets total blocks
| -pc_asm_overlap <ovl> | - Sets overlap
| -pc_asm_type [basic,restrict,interpolate,none] | - Sets ASM type, default is restrict
| -pc_asm_local_type [additive, multiplicative] | - Sets ASM type, default is additive

IMPORTANT: If you run with, for example, 3 blocks on 1 processor or 3 blocks on 3 processors you will get a different convergence rate due to the default option of -pc_asm_type restrict. Use -pc_asm_type basic to use the standard ASM.

### Notes

Each processor can have one or more blocks, but a block cannot be shared by more than one processor. Use PCGASM for subdomains shared by multiple processes. Defaults to one block per processor.

To set options on the solvers for each block append -sub_ to all the KSP, and PC options database keys. For example, -sub_pc_type ilu -sub_pc_factor_levels 1 -sub_ksp_type preonly

To set the options on the solvers separate for each block call PCASMGetSubKSP() and set the options directly on the resulting KSP object (you can access its PC with KSPGetPC())

### References

| 1. | - M Dryja, OB Widlund, An additive variant of the Schwarz alternating method for the case of many subregions Courant Institute, New York University Technical report
| 1. | - Barry Smith, Petter Bjorstad, and William Gropp, Domain Decompositions: Parallel Multilevel Methods for Elliptic Partial Differential Equations, Cambridge University Press.

### See Also

PCCreate(), PCSetType(), PCType (for list of available types), PC,
PCBJACOBI, PCASMGetSubKSP(), PCASMSetLocalSubdomains(), PCASMType, PCASMGetType(), PCASMSetLocalType(), PCASMGetLocalType() PCASMSetTotalSubdomains(), PCSetModifySubmatrices(), PCASMSetOverlap(), PCASMSetType(), PCCompositeType

### Level

beginner

### Location

src/ksp/pc/impls/asm/asm.c

### Examples

src/ksp/ksp/examples/tutorials/ex6.c.html
src/ksp/ksp/examples/tutorials/ex8.c.html
Index of all PC routines
Table of Contents for all manual pages
Index of all manual pages